function [x1, x2] = solve2(a, b, c)
%SOLVE2 Solves a quadratic equation AX^2 + BX + C

% Calcoliamo il delta, che contiene una cancellazione "inevitabile"
d = sqrt(b^2 - 4 * a * c);

% ... ma evitiamo di introdurre più errori del necessario calcolando solo
% la soluzione che possiamo ottenere senza cancellazione
if b > 0
    x1 = (-b - d) / (2 * a);
else
    x1 = (-b + d) / (2 * a);
end

% L'altra soluzione la otteniamo sfruttando la relazione x1 * x2 = c / a;
x2 = c / (a * x1);

end

